<script setup lang="ts">
import { reactive, ref, onMounted, computed } from 'vue';
import axios from 'axios';
import { genFileId } from 'element-plus';
import type { UploadInstance, UploadProps, UploadRawFile } from 'element-plus';
import * as echarts from 'echarts';

const upload = ref<UploadInstance>();
const handleExceed: UploadProps['onExceed'] = (files) => {
  upload.value!.clearFiles();
  const file = files[0] as UploadRawFile;
  file.uid = genFileId();
  upload.value!.handleStart(file);
};

const data = ref({table:null, GLEU:null, PTM2:null,});
// const data = ref({
//   table: {
//     name: [
//       '总体',
//       '其他',
//       '方位名词',
//       '能愿动词',
//       '疑问代词',
//       '人称代词',
//       '指示代词',
//       '数词',
//       '名量词',
//       '程度副词',
//       '范围、协同副词',
//       '时间副词',
//       '频率、重复副词',
//       '关联副词',
//       '否定副词',
//       '引出时间、处所',
//       '引出对象',
//       '连接词或词组',
//       '结构助词',
//       '动态助词',
//       '语气助词',
//       '形容词重叠',
//       '动量词',
//       '时量词',
//       '方式副词',
//       '情态副词',
//       '语气副词',
//       '引出方向、路径',
//       '引出目的、原因',
//       '连接分句或句子',
//       '助词',
//       '其他助词',
//       '叹词',
//       '离合词',
//       '引出施事、受事',
//       '表示排除',
//       '引出凭借、依据',
//       '拟声词',
//       '借用量词',
//     ],
//     precision: [
//       54.37, 39.66, 27.59, 33.33, 33.33, 20.0, 26.67, 50.0, 24.0, 40.43, 41.67,
//       26.51, 40.0, 22.73, 45.0, 45.16, 32.91, 16.67, 30.29, 27.45, 33.33, 9.09,
//       20.0, 0.0, 66.67, 60.0, 40.0, 25.0, 22.58, 42.5, 40.0, 57.14, 100.0,
//       66.67, 22.22, 50.0, 50.0, 100.0, 0.0,
//     ],
//     recall: [
//       4.44, 2.29, 5.93, 10.93, 4.49, 10.85, 2.52, 0.74, 1.08, 7.66, 14.15,
//       15.28, 17.14, 6.21, 2.79, 18.92, 28.26, 9.09, 21.99, 28.19, 50.0, 2.44,
//       1.09, 0.0, 40.0, 37.5, 11.11, 14.29, 14.89, 17.17, 10.53, 40.0, 100.0,
//       25.0, 6.67, 100.0, 28.57, 100.0, 0.0,
//     ],
//     'f0.5': [
//       16.74, 9.31, 15.94, 23.64, 14.6, 17.11, 9.15, 3.51, 4.57, 21.79, 30.0,
//       23.11, 31.58, 14.84, 11.17, 35.35, 31.86, 14.29, 28.16, 27.6, 35.71, 5.88,
//       4.46, 0.0, 58.82, 53.57, 26.32, 21.74, 20.47, 32.82, 25.64, 52.63, 100.0,
//       50.0, 15.15, 55.56, 43.48, 100.0, 0.0,
//     ],
//   },
//   GLEU: 0.767,
//   PTM2: 0.341,
// });

const names = computed(() => {
  return Object.keys(data.value);
});

const tableData = computed(() => {
  console.log(GLEU.value);
  // const { GLEU, PTM2 } = data.value;
  return [
    { GLEU, PTM2 },
    // { name: 'GLEU', val: GLEU },
    // { name: 'PTM2', val: PTM2 },
  ];
});

const keys = ['f0.5', 'precision', 'recall'];

// const chartData = computed(() => {
//   const res = { 'f0.5': [], 'precision': [], 'recall': [] };
//   names.value.forEach((name) => {
//     keys.forEach((key: string) => {
//       res[key].push(data.value[name][key])
//     })
//   })
//   return res;
// })

var myChart: any;

const initChart = () => {
  console.log(data.value);
  var option = {
    tooltip: {
      trigger: 'axis',
      axisPointer: {
        type: 'shadow',
        label: {
          show: true,
        },
      },
    },
    legend: {},
    // grid: {
    //   // top: '5%',
    //   // left: '1%',
    //   // right: '10%',
    //   containLabel: true,
    // },
    xAxis: [
      {
        type: 'category',
        data: data.value.name,
        axisLabel: {
          rotate: 45,
        },
      },
    ],
    yAxis: [
      {
        type: 'value',
      },
    ],
    series: [
      {
        name: keys[0],
        type: 'bar',
        data: data.value[keys[0]],
      },
      {
        name: keys[1],
        type: 'bar',
        data: data.value[keys[1]],
      },
      {
        name: keys[2],
        type: 'bar',
        data: data.value[keys[2]],
      },
    ],
  };
  myChart.setOption(option);
  option && myChart.setOption(option);
};
onMounted(() => {
  var chartDom = document.getElementById('chartRef') as HTMLElement;
  myChart = echarts.init(chartDom);
  // initChart();
});

const GLEU = ref();
const PTM2 = ref();

const submit = () => {
  // initChart();
  myChart.showLoading();
  axios.get('/api/evaluate').then((res) => {
    console.log(res);
    const { GLEU: GLEU2, PTM2: PTM, table } = res.data;
    GLEU.value = GLEU2;
    PTM2.value = PTM;
    data.value = table;
    initChart();
    myChart.hideLoading();
  });
};

const get_example_data = () => {
  // initChart();
  myChart.showLoading();
  axios.get('/api/evaluate_example').then((res) => {
    console.log(res);
    const { GLEU: GLEU2, PTM2: PTM, table } = res.data;
    GLEU.value = GLEU2;
    PTM2.value = PTM;
    data.value = table;
    initChart();
    myChart.hideLoading();
  });
};
</script>


<template>
  <el-row type="flex" justify="space-around" style="margin-top: 20px">
    <el-upload
      ref="upload"
      class="upload-demo"
      action="/api/upload_predict"
      :limit="1"
      :on-exceed="handleExceed"
    >
      <template #trigger>
        <el-button type="primary">上传预测文件</el-button>
      </template>
      <template #tip>
        <div class="el-upload__tip text-red">
          格式为每行一句预测语句
          <a href="http://cgecdemo.shuishan.net.cn/api/download_predict" download >下载示例</a>
        </div>
      </template>
    </el-upload>
    <el-upload
      ref="upload"
      class="upload-demo"
      action="/api/upload_correct"
      :limit="1"
      :on-exceed="handleExceed"
    >
      <template #trigger>
        <el-button type="primary">上传标准答案文件</el-button>
      </template>
      <template #tip>
        <div class="el-upload__tip text-red">
          M2标注文件或每行以tab分割的原文本-正确文本对齐文件
          <a href="http://cgecdemo.shuishan.net.cn/api/download_dataset" download >下载示例1</a>
          <a href="http://cgecdemo.shuishan.net.cn/api/download_dataset2" download >下载示例2</a>
          <!-- target="_blank" -->
        </div>
      </template>
    </el-upload>
    <div class="btn-wrap">
      <el-button  @click="submit">提交</el-button>
      <el-button type="text" size="small" style="display: block;" @click="get_example_data">运行示例文件</el-button>
    </div>
  </el-row>
  <div id="chartRef"></div>
  <!-- {{ names }} -->
  <!-- <div>{{ chartData }}</div> -->
  <!-- <div v-if="GLEU" class="GLEU">GLEU: {{ GLEU }}</div>
  <div v-if="PTM2" class="PTM2">PT-M2: {{ PTM2 }}</div> -->
  <el-table :data="tableData" border class="table" v-if="GLEU||PTM2">
    <el-table-column prop="GLEU" align="center" label="GLEU" v-if="GLEU"></el-table-column>
    <el-table-column prop="PTM2" align="center" label="PT-M2" v-if="PTM2"></el-table-column>
  </el-table>
</template>

<style scoped lang="scss">
#chartRef {
  height: 450px;
}

.table {
  width: 50vw;
  margin: 0 auto;
  margin-top: 30px;
}

.btn-wrap {
  display: flex;
  flex-direction: column;
  button {
    margin: 0px 0 3px;
  }
}
</style>
